<?php
set_time_limit(0);
error_reporting(1);

$argc = $_SERVER['argc'];
$argv = $_SERVER['argv'];

$create_oem_only = false;
$ignore_deleted_folder = false;
if ($argc == 2 && strcasecmp($argv[1], "ignore_deleted_folder") == 0)
    $ignore_deleted_folder = true;
else if ($argc == 2 && strcasecmp($argv[1], "create_oem_only") == 0)
    $create_oem_only = true;

$sys_folder = 'SYS';
$oem_folder = 'OEM';
$lite_folder = 'LITE';
$deleted_folder = 'deleted';

if (!is_dir($sys_folder)) {
    echo "No SYS folder under current directory!\n";
    exit;
}

if (!is_dir($oem_folder)) {
    echo "No OEM folder under current directory!\n";
    exit;
}

if (!is_dir($lite_folder)) {
    echo "No LITE folder under current directory!\n";
    exit;
}

$lang = FindLanguage($sys_folder);

if ($lang === false) {
    echo "Can't detect langauge from SYS folder\n";
    exit;
}

echo "CurLang = $lang\n";

if (!$ignore_deleted_folder && !$create_oem_only && file_exists($deleted_folder)) {
    echo "deleted folder already exist, please delete it before run this program!\n";
    exit;
}
@mkdir($deleted_folder);
if (!is_dir($deleted_folder)) {
    echo "Can't create deleted folder.\n";
    exit;
}

$lite_lang = '';
$fp = fopen($lite_folder.'\\lang.txt', 'rt');
if ($fp !== 0) {
    $lite_lang = trim(fgets($fp));
    fclose($fp);
    echo "Lang in LITE = $lite_lang\n";
}

if (!$create_oem_only) {
    // process deleted files
    $fp = fopen($lite_folder.'\\deleted_files.txt', 'rt');
    if ($fp !== 0) {
        echo "Processing deleted_files.txt\n";
        $deleted_files = array();
        while (!feof($fp)) {
            $file = strtolower(trim(fgets($fp)));
            if ($file === '') continue;
            $deleted_files[] = $file;
            if ($lite_lang !== '') {
                if (strcmp(substr($file, -4), '.exe') == 0 || strcmp(substr($file, -4), '.dll') == 0) {
                    // automatic add the mui file for exe and dll
                    $deleted_files[] = $file.'.'.$lite_lang.'.mui';
                }
            }
        }
        fclose(fp);

        foreach (array($sys_folder, $oem_folder) as $root_folder) {
            $dh = opendir($root_folder);
            if (!$dh) {
                echo "opendir() failed for $root_folder\n";
                continue;
            }

            while (($file = readdir($dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                $folder_name = $root_folder.'\\'.$file;
                // only process directory
                if (filetype($folder_name) !== 'dir') continue;
                // skip OEM\zzzXXXXXX
                if (strncasecmp($folder_name, 'OEM\\zzz', 7) == 0) continue;

                echo "Processing directory: $folder_name\n";
                $sub_dh = opendir($folder_name);
                if (!$sub_dh) {
                    echo "opendir() failed for $folder_name\n";
                    continue;
                }
                while (($file = readdir($sub_dh)) !== false) {
                    if ($file == '.' || $file == '..') continue;
                    $lwr_file = strtolower($file);
                    $full_name = $folder_name.'\\'.$file;
                    if (in_array($lwr_file, $deleted_files)) {
                        echo "$file\n";
                        @mkdir($deleted_folder.'\\'.$root_folder);
                        @mkdir($deleted_folder.'\\'.$folder_name);
                        $new_full_name = $deleted_folder.'\\'.$full_name;
                        rename($full_name, $new_full_name);
                    }
                    else if ($lite_lang !== '') {
                        $new_file = str_replace($lang, $lite_lang, $file);
                        $lwr_new_file = strtolower($new_file);
                        if (in_array($lwr_new_file, $deleted_files)) {
                            echo "$file (replace language to $new_file)\n";
                            @mkdir($deleted_folder.'\\'.$root_folder);
                            @mkdir($deleted_folder.'\\'.$folder_name);
                            $new_full_name = $deleted_folder.'\\'.$full_name;
                            rename($full_name, $new_full_name);
                        }
                    }
                }
                closedir($sub_dh);
            }
            closedir($dh);
        }
        $deleted_files = array();
        unset($deleted_files);
    }

    // delete the file if only have .dsm
    echo "Processing .dsm only\n";
    $dh = opendir($sys_folder);
    if ($dh) {
        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $folder_name = $sys_folder.'\\'.$file;
            // only process directory
            if (filetype($folder_name) !== 'dir') continue;

            echo "Processing directory: $folder_name\n";
            $sub_dh = opendir($folder_name);
            if (!$sub_dh) {
                echo "opendir() failed for $folder_name\n";
                continue;
            }
            $count = 0;
            while (($file = readdir($sub_dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                // skip .dsm files
                if (strcasecmp(substr($file, -4), '.dsm') == 0) continue;
                $count++;
            }
            closedir($sub_dh);
            if ($count == 0) {
                // only .dsm for this folder
                $sub_dh = opendir($folder_name);
                if (!$sub_dh) {
                    echo "opendir() failed for $folder_name\n";
                    continue;
                }
                while (($file = readdir($sub_dh)) !== false) {
                    if ($file == '.' || $file == '..') continue;
                    $full_name = $folder_name.'\\'.$file;
                    echo "$file\n";
                    @mkdir($deleted_folder.'\\'.$sys_folder);
                    @mkdir($deleted_folder.'\\'.$folder_name);
                    $new_full_name = $deleted_folder.'\\'.$full_name;
                    rename($full_name, $new_full_name);
                }
                closedir($sub_dh);
            }
        }
        closedir($dh);
    }

    // process deleted registry
    $fp = fopen($lite_folder.'\\deleted_registry.txt', 'rt');
    if ($fp !== 0) {
        echo "Processing deleted_registry.txt\n";
        $deleted_registey = array();
        $deleted_registry_item = array();
        $bom1 = fread($fp, 1);
        $bom2 = fread($fp, 1);
        if (ord($bom1) !== 255 && ord($bom2) != 254) {
            echo "This file is not a UTF16-LE format.\n";
        }
        else {
            $item_mode = false;
            $item_key = '';
            while (!feof($fp)) {
                $str = fgets($fp);
                if (ord(substr($str, 0, 1)) == 0 && ord(substr($str, 1, 1)) != 0) {
                    // remove first 0x00
                    $key = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', substr($str, 1)));
                }
                else
                    $key = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', $str));
                if ($key === '') continue;
                if (substr($key, 0, 1) == '!') {
                    $item_mode = true;
                    continue;
                }
                if (!$item_mode) {
                    if (substr($key, 0, 1) == '[')
                        $deleted_registry[] = $key;
                    continue;
                }
                // item mode here
                if (substr($key, 0, 1) == '[') {
                    $item_key = $key;
                    continue;
                }
                if ($item_key === '') {
                    echo "format error, no item key.\n";
                    continue;
                }
                $deleted_registry_item[$item_key][] = $key;
            }
        }
        fclose(fp);
        if (count($deleted_registry) != 0 || count($deleted_registry_item) != 0) {
            foreach (array($sys_folder, $oem_folder) as $root_folder) {
                $dh = opendir($root_folder);
                if (!$dh) {
                    echo "opendir() failed for $root_folder\n";
                    continue;
                }

                while (($file = readdir($dh)) !== false) {
                    if ($file == '.' || $file == '..') continue;
                    $folder_name = $root_folder.'\\'.$file;
                    // only process directory
                    if (filetype($folder_name) !== 'dir') continue;
                    // skip OEM\zzzXXXXXXX
                    if (strncasecmp($folder_name, 'OEM\\zzz', 7) == 0) continue;

                    echo "Processing directory: $folder_name\n";
                    $sub_dh = opendir($folder_name);
                    if (!$sub_dh) {
                        echo "opendir() failed for $folder_name\n";
                        continue;
                    }
                    while (($file = readdir($sub_dh)) !== false) {
                        if ($file == '.' || $file == '..') continue;
                        // skip non .rgu files
                        if (strcasecmp(substr($file, -4), '.rgu')) continue;
                        $full_name = $folder_name.'\\'.$file;
                        // found .rgu here
                        echo "Processing $full_name\n";
                        $fp = fopen($full_name, "rt");
                        if ($fp == 0) {
                            echo "Can't open file: $full_name\n";
                            continue;
                        }
                        $bom1 = fread($fp, 1);
                        $bom2 = fread($fp, 1);
                        if (ord($bom1) !== 255 && ord($bom2) != 254) {
                            fclose($fp);
                            echo "This file is not a UTF16-LE format.\n";
                            continue;
                        }
                        $tmp_file = $lite_folder.'\\'.$file;
                        $tmp_fp = fopen($tmp_file, 'wb');
                        if ($tmp_fp == 0) {
                            fclose($fp);
                            echo "Can't create tmp file: $tmp_file\n";
                            continue;
                        }
                        // write BOM
                        fwrite($tmp_fp, chr(255), 1);
                        fwrite($tmp_fp, chr(254), 1);
                        $modified = false;
                        $deleted_key = false;
                        $deleted_item = false;
                        $item_key = '';
                        while (!feof($fp)) {
                            $str = fgets($fp);
                            if (ord(substr($str, 0, 1)) == 0 && ord(substr($str, 1, 1)) != 0) {
                                // remove first 0x00
                                $key = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', substr($str, 1)));
                            }
                            else
                                $key = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', $str));
                            if (substr($key, 0, 1) == '[') {
                                $deleted_key = false;
                                $deleted_item = false;
                                if (in_array($key, $deleted_registry)) {
                                    $deleted_key = true;
                                    $modified = true;
                                    echo "Delete registry: $key\n";
                                    continue;
                                }
                                if (isset($deleted_registry_item[$key])) {
                                    echo "try to found item for $key\n";
                                    $item_key = $key;
                                    $deleted_item = true;
                                }
                            }
                            if ($deleted_key) continue;
                            if ($deleted_item) {
                                $pos = strpos($key, '=');
                                if ($pos !== false) {
                                    $item = substr($key, 0, $pos);
                                    if (in_array($item, $deleted_registry_item[$item_key])) {
                                        $modified = true;
                                        echo "Delete item: $item from registry $item_key\n";
                                        continue;
                                    }
                                }
                            }
                            // nothing, so just output it
                            fwrite($tmp_fp, iconv('UTF-8', 'UTF-16LE//IGNORE', $key."\r\n"));
                        }
                        fclose($fp);
                        fclose($tmp_fp);
                        if (!$modified) {
                            echo "Skip non-modified file: $tmp_file\n";
                            unlink($tmp_file);
                            continue;
                        }
                        echo "move $full_name to $deleted_folder\\$file\n";
                        rename($full_name, $deleted_folder.'\\'.$file);
                        echo "move $tmp_file to $full_name\n";
                        rename($tmp_file, $full_name);
                    }
                    closedir($sub_dh);
                }
                closedir($dh);
            }
        }
    }
}

// move file to OEM folder
$dh = opendir($lite_folder.'\\OEM');
if ($dh) {
    $count = 0;
    $my_id = strftime('%y%m-%d%H-%M%S');
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        $file_name = $lite_folder.'\\OEM\\'.$file;
        if (!is_file($file_name)) continue;
        // load .txt only
        if (strcasecmp(substr($file, -4), '.txt')) continue;
        $count++;
        $package_name = substr($file, 0, -4);
        $oem_folder_name = 'zzzOEM_'.str_replace(' ', '_', $package_name);

        $guid = '';
        echo "Process OEM Package: $package_name\n";
        $full_folder_name = $oem_folder.'\\'.$oem_folder_name;
        if (file_exists($full_folder_name)) {
            // folder already exist, try to get GUID
            $xml_file = $full_folder_name.'\\option.xml';
            $content = file_get_contents($xml_file);
            preg_match("#<Guid(.*)>(.*)</Guid>#", $content, $matches);
            if (count($matches) != 0) {
                $guid = $matches[2];
                echo "Exist GUID: $guid\n";
            }
        }
        if (!file_exists($full_folder_name) || $guid == '') {
            @mkdir($full_folder_name);
            // generate .dsm file, and option.xml
            $guid = 'ffffffff-'.$my_id.'-'.sprintf('%012d', $count);
            echo "New GUID: $guid\n";
            $dsm_file = $full_folder_name.'\\'.$guid.'.dsm';
            $fp = fopen($dsm_file, "wt");
            if ($fp == 0) {
                echo "Can't create file: $dsm_file\n";
                continue;
            }
            fclose($fp);
            $xml_file = $full_folder_name.'\\option.xml';
            $fp = fopen($xml_file, "wt");
            if ($fp == 0) {
                echo "Can't create file: $xml_file\n";
                continue;
            }
            fputs($fp, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<Items>
<Item name="'.$package_name.'" group="OEM" checked="false">
<Tip>'.$package_name.'</Tip>
<Guid type="p">'.$guid.'</Guid>
<OEMDate>2010/4/12</OEMDate>
</Item>
</Items>');
            fclose($fp);
        }
        MoveFileToOEM($full_folder_name, $deleted_folder, $file_name, $lang, $lite_lang, $guid);
    }
    closedir($dh);
}


// delete empty OEM folder
$dh = opendir($oem_folder);
if ($dh) {
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        $folder_name = $oem_folder.'\\'.$file;
        // only process directory
        if (filetype($folder_name) !== 'dir') continue;
        //  only process OEM\zzzOEM_XXXXXX
        if (strncasecmp($folder_name, 'OEM\\zzzOEM_', 11) != 0) continue;
        $count = 0;
        echo "Processing directory: $folder_name\n";

        $guid = '';
        // folder already exist, try to get GUID
        $xml_file = $folder_name.'\\option.xml';
        $content = file_get_contents($xml_file);
        preg_match("#<Guid(.*)>(.*)</Guid>#", $content, $matches);
        if (count($matches) != 0) {
            $guid = $matches[2];
        }

        $sub_dh = opendir($folder_name);
        if (!$sub_dh) {
            echo "opendir() failed for $folder_name\n";
            continue;
        }
        while (($file = readdir($sub_dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            // skip .dsm files
            if (strcasecmp(substr($file, -4), '.dsm') == 0) continue;
            // skip option.xml
            if (strcasecmp($file, 'option.xml') == 0) continue;
            // skip $guid.rgu file
            if ($guid !== ''&& strcasecmp($file, $guid.'.rgu') == 0) continue;
            $count++;
        }
        closedir($sub_dh);

        if ($count == 0) {
            // empty, deleted option.xml to hide it from BuildOS
            unlink($folder_name.'\\option.xml');
        }
    }
    closedir($dh);
}

exit;

function FindLanguage($root_folder)
{
    $dh = opendir($root_folder);
    if (!$dh) {
        echo "opendir() failed for $root_folder\n";
        return false;
    }
    $lang = false;
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        $full_name = $root_folder.'\\'.$file;
        if (!is_dir($full_name)) continue;
        if (strlen($file) != 14) continue;
        if (strncasecmp($file, 'Base_Lang_', 10)) continue;
        $lang = substr($file, 10);
        break;
    }
    closedir($dh);
    return $lang;
}

function MoveFileToOEM($full_folder_name, $deleted_folder, $file_name, $lang, $lite_lang, $guid)
{
    //echo "Moving file to $full_folder_name\n";
    $have_rgu = false;
    $fp = fopen($file_name, 'rt');
    if ($fp == 0) return;
    $oem_files = array();
    while (!feof($fp)) {
        $file = strtolower(trim(fgets($fp)));
        if ($file === '') continue;
        $oem_files[] = $file;
        if ($lite_lang !== '') {
            if (strcmp(substr($file, -4), '.exe') == 0 || strcmp(substr($file, -4), '.dll') == 0) {
                // automatic add the mui file for exe and dll
                $oem_files[] = $file.'.'.$lite_lang.'.mui';
            }
        }
    }
    fclose(fp);

    foreach (array($deleted_folder.'\\SYS', $deleted_folder.'\\OEM') as $root_folder) {
        $dh = opendir($root_folder);
        if (!$dh) {
            echo "opendir() failed for $root_folder\n";
            continue;
        }

        while (($file = readdir($dh)) !== false) {
            if ($file == '.' || $file == '..') continue;
            $folder_name = $root_folder.'\\'.$file;
            // only process directory
            if (filetype($folder_name) !== 'dir') continue;

            //echo "Processing directory: $folder_name\n";
            $sub_dh = opendir($folder_name);
            if (!$sub_dh) {
                echo "opendir() failed for $folder_name\n";
                continue;
            }
            while (($file = readdir($sub_dh)) !== false) {
                if ($file == '.' || $file == '..') continue;
                // skip .dsm file, we already have oem dsm file
                if (strcasecmp(substr($file, -4), '.dsm') == 0) continue;
                $full_name = $folder_name.'\\'.$file;
                $lwr_file = strtolower($file);
                if (in_array($lwr_file, $oem_files)) {
                    echo "$file\n";
                    $new_full_name = $full_folder_name.'\\'.$file;
                    rename($full_name, $new_full_name);
                }
                else if ($lite_lang !== '') {
                    $new_file = str_replace($lang, $lite_lang, $file);
                    $lwr_new_file = strtolower($new_file);
                    if (in_array($lwr_new_file, $oem_files)) {
                        echo "$file (replace language to $new_file)\n";
                        $new_full_name = $full_folder_name.'\\'.$file;
                        rename($full_name, $new_full_name);
                    }
                }
            }
            closedir($sub_dh);
        }
        closedir($dh);
    }

    // make sure there's only only .dsm with guid
    //echo "Checking .dsm files\n";
    $dh = opendir($full_folder_name);
    if (!$dh) {
        echo "opendir() failed for $full_folder_name\n";
        return;
    }

    $dsm_exists = false;
    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        // skip non .dsm files
        if (strcasecmp(substr($file, -4), '.dsm')) continue;
        // .dsm here
        if (strcasecmp($file, $guid.'.dsm') == 0) {
            $dsm_exists = true;
            continue;
        }
        // other .dsm,
        system("attrib -r -h -s \"$full_folder_name\\$file\"");
        unlink($full_folder_name.'\\'.$file);
    }
    closedir($dh);
    if (!$dsm_exists) {
        $fp = fopen($full_folder_name.'\\'.$guid.'.dsm', "wt");
        if (!$fp)
            fclose($fp);
    }

    // merge .rgu file to $guid.dsm
    //echo "Merging .rgu files\n";
    $dh = opendir($full_folder_name);
    if (!$dh) {
        echo "opendir() failed for $full_folder_name\n";
        return;
    }

    $lines = 0;
    $rgu_file = $full_folder_name.'\\'.$guid.'.rgu';
    $fp = fopen($rgu_file, "wb");
    if ($fp == 0) {
        closedir($dh);
        echo "Can't create $rgu_file file\n";
        return;
    }
    // write BOM
    fwrite($fp, chr(255), 1);
    fwrite($fp, chr(254), 1);
    fwrite($fp, iconv('UTF-8', 'UTF-16LE//IGNORE', "REGEDIT4\r\n"));

    while (($file = readdir($dh)) !== false) {
        if ($file == '.' || $file == '..') continue;
        // skip non .rgu files
        if (strcasecmp(substr($file, -4), '.rgu')) continue;
        // skip myself
        if (strcasecmp($file, $guid.'.rgu') == 0) continue;
        $rgu_fp = fopen($full_folder_name.'\\'.$file, "rt");
        $bom1 = fread($rgu_fp, 1);
        $bom2 = fread($rgu_fp, 1);
        if (ord($bom1) !== 255 && ord($bom2) != 254) {
            fclose($rgu_fp);
            echo "$file is not a UTF16-LE format.\n";
            continue;
        }
        while (!feof($rgu_fp)) {
            $str = fgets($rgu_fp);
            if (ord(substr($str, 0, 1)) == 0 && ord(substr($str, 1, 1)) != 0) {
                // remove first 0x00
                $utf8str = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', substr($str, 1)));
            }
            else
                $utf8str = trim(iconv('UTF-16LE', 'UTF-8//IGNORE', $str));
            if (strcasecmp($utf8str, 'REGEDIT4') == 0) continue;
            if (strncasecmp($utf8str, 'Windows Registry Editor Version', strlen('Windows Registry Editor Version')) == 0) continue;
            fwrite($fp, iconv('UTF-8', 'UTF-16LE//IGNORE', $utf8str."\r\n"));
            $line++;
        }
        fclose($rgu_fp);
    }
    fclose($fp);
    closedir($dh);
    if ($line == 0) {
        // empty rgu files, delete it
        unlink($rgu_file);
    }
    return;
}

?>
